#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=C:\Dokumente und Einstellungen\Privat-Pc\Eigene Dateien\My AutoIt3 Scripts\SE_orange.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Comment=SynthEdit Launcher
#AutoIt3Wrapper_Res_Description=The SE_Launcher helps to keep two different Synthedit installations on the same computer
#AutoIt3Wrapper_Res_LegalCopyright=(c) Andreas Sumerauer 2008
#AutoIt3Wrapper_Res_SaveSource=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Res_Icon_Add=C:\Dokumente und Einstellungen\Privat-Pc\Eigene Dateien\My AutoIt3 Scripts\SE_orange.ico

#include <GUIConstants.au3>
#include <Array.au3>

Dim $iniSection, $iniKey, $caption, $fileFilter
Dim $dir, $fullName
$iniFileName = @ScriptDir & "\SE_Launcher.ini"
$baseKeyPath = "HKEY_CURRENT_USER\Software\CineStar\SynthEdit\SYNTHEDIT\"

If $CmdLine[0] >= 1 Then
	If $CmdLine[1] == "SE_10" Then
		$iniSection = "Synthedit_1.0"
		launch()
	ElseIf $CmdLine[1] == "SE_11" Then	
		$iniSection = "Synthedit_1.1"
		launch()
	Else
		runDialog()
	EndIf	
Else	
	runDialog()
EndIf

Func runDialog()
	$check = true
	While($check)
		$check = small_GUI()
		GUIDelete()
		if $check Then 
			$check = large_GUI()
			GUIDelete()
		EndIf	
	WEnd	
EndFunc

Func small_GUI()
	#Region ### START Koda GUI section ### Form=c:\dokumente und einstellungen\privat-pc\eigene dateien\my autoit3 scripts\se launcher.kxf
	$Form1_1 = GUICreate("SE Launcher", 305, 52, default, default)
	$SE_10 = GUICtrlCreateButton("SE 1.0", 8, 8, 105, 33, 0)
	$SE_11 = GUICtrlCreateButton("SE 1.1", 120, 8, 105, 33, 0)
	$config = GUICtrlCreateButton("config >>", 232, 24, 65, 17, 0)
	$cancel = GUICtrlCreateButton("cancel", 232, 8, 65, 17, 0)

	GUISetState(@SW_SHOW)

	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				return False
			Case $cancel
				return False
			Case $config
				return True
			Case $SE_10
				$iniSection = "Synthedit_1.0"
				launch()
				return False
			Case $SE_11
				$iniSection = "Synthedit_1.1"
				launch()
				return False				
		EndSwitch
	WEnd
EndFunc	

Func large_GUI()
	#Region ### START Koda GUI section ### Form=c:\dokumente und einstellungen\privat-pc\eigene dateien\my autoit3 scripts\se launcher.kxf
	$Form1_1 = GUICreate("SE Launcher", 572, 192, default, default)
	$SE_10 = GUICtrlCreateButton("SE 1.0", 8, 8, 105, 33, 0)
	$SE_11 = GUICtrlCreateButton("SE 1.1", 120, 8, 105, 33, 0)
	$config = GUICtrlCreateButton("config <<", 232, 24, 65, 17, 0)
	$cancel = GUICtrlCreateButton("cancel", 232, 8, 65, 17, 0)
	
	$SE10_Title = GUICtrlCreateGroup ( "SE 1.0 File Locations", 4, 56 , 564 , 62 ) 
	$10_SEM = GUICtrlCreateLabel("SEM:", 40, 76, 30, 17)
	$10_EXE = GUICtrlCreateLabel("Exe:", 40, 96, 30, 17)
	$10_Button_SEM = GUICtrlCreateButton("...", 8, 72, 25, 19, 0)
	$10_Button_Exe = GUICtrlCreateButton("...", 8, 92, 25, 19, 0)

	$dir = IniRead($iniFileName, "Synthedit_1.0", "ModulePath", "")
	if NOT FileExists($dir) OR $dir == "" Then
		$dir = RegRead( $baseKeyPath , "ModulePath" )
		$ctlState = $GUI_DISABLE
	Else
		$ctlState = $GUI_ENABLE
	EndIf	
	$10_Label_SEM = GUICtrlCreateLabel($dir, 80, 76, 483, 17)
	GUICtrlSetState ( $10_Label_SEM, $ctlState )
	
	$dir = IniRead($iniFileName, "Synthedit_1.0", "exePath", "")
	if NOT FileExists($dir) OR $dir == "" Then
		$dir = RegRead( $baseKeyPath , "ExePath" )
	EndIf
	$10_Label_Exe = GUICtrlCreateLabel($dir, 80, 96, 483, 17)

	$SE11_Title = GUICtrlCreateGroup ( "SE 1.1 File Locations", 4, 126 , 564 , 62 ) 
	$11_SEM = GUICtrlCreateLabel("SEM:", 40, 146, 30, 17)
	$11_Exe = GUICtrlCreateLabel("Exe:", 40, 166, 30, 17)
	$11_Button_SEM = GUICtrlCreateButton("...", 8, 142, 25, 19, 0)
	$11_Button_Exe = GUICtrlCreateButton("...", 8, 162, 25, 19, 0)
	
	$dir = IniRead($iniFileName, "Synthedit_1.1", "ModulePath", "")
	if NOT FileExists($dir) OR $dir == "" Then
		$dir = RegRead( $baseKeyPath , "ModulePath" )
		$ctlState = $GUI_DISABLE
	Else
		$ctlState = $GUI_ENABLE
	EndIf	
	$11_Label_SEM = GUICtrlCreateLabel($dir, 80, 146, 483, 17)
	GUICtrlSetState ( $11_Label_SEM, $ctlState )
	
	$dir = IniRead($iniFileName, "Synthedit_1.1", "exePath", "")
	if NOT FileExists($dir) OR $dir == "" Then
		$dir = RegRead( $baseKeyPath , "ExePath" )
	EndIf
	$11_Label_Exe = GUICtrlCreateLabel($dir, 80, 166, 483, 17)

	GUISetState(@SW_SHOW)

	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				return False
			Case $cancel
				return False
			Case $config
				return True
			Case $SE_10
				$iniSection = "Synthedit_1.0"
				launch()
				return False
			Case $SE_11
				$iniSection = "Synthedit_1.1"
				launch()
				return False				

			Case $10_Button_SEM
				$iniSection = "Synthedit_1.0"
				$iniKey = "ModulePath"
				$caption = "Set SE 1.0 Module File Path"
				$fileFilter =  "All Files (*.*)"
				If getSaveDirName($dir) Then
					GUICtrlSetData($10_Label_SEM, $dir)
					GUICtrlSetState ($10_Label_SEM, $GUI_ENABLE)
				EndIf
			Case $10_Button_exe
				$iniSection = "Synthedit_1.0"
				$iniKey = "ExePath"
				$caption = "Set SE 1.0 Exe File Path"
				$fileFilter =  "SynthEdit Executable (SynthEdit.exe)"
				If getSaveExeName($fullname) Then
					GUICtrlSetData($10_Label_Exe, $fullname)
				EndIf

			Case $11_Button_SEM
				$iniSection = "Synthedit_1.1"
				$iniKey = "ModulePath"
				$caption = "Set SE 1.1 Module File Path"
				$fileFilter =  "All Files (*.*)"
				If getSaveDirName($dir) Then
					GUICtrlSetData($11_Label_SEM, $dir)
					GUICtrlSetState ($11_Label_SEM, $GUI_ENABLE)
				EndIf
			Case $11_Button_exe
				$iniSection = "Synthedit_1.1"
				$iniKey = "ExePath"
				$caption = "Set SE 1.1 Exe File Path"
				$fileFilter =  "SynthEdit Executable (SynthEdit.exe)"
				If getSaveExeName($fullname) Then
					GUICtrlSetData($11_Label_Exe, $fullname)
				EndIf
		EndSwitch
	WEnd
EndFunc	


Func launch()
	GUISetState(@SW_HIDE)
	$dir = IniRead($iniFileName, $iniSection, "ModulePath", "")
	if FileExists($dir) AND $dir <> "" Then
		RegWrite ( $baseKeyPath , "ModulePath", "REG_SZ", $dir )
	EndIf	
	
	$exe = IniRead($iniFileName, $iniSection, "ExePath", "")
	if NOT FileExists($exe) OR $exe == "" Then
		$iniKey = "ExePath"
		$caption = "Set " & $iniSection & " Exe File Path"
		$fileFilter =  "SynthEdit Executable (SynthEdit.exe)"
		If NOT getSaveExeName($exe) Then
			Return
		EndIf
	EndIf
	ini2registry()
	RunWait($exe)
	registry2ini()
EndFunc

Func ini2registry()
	ini2reg( "MidiPath", "REG_SZ" )
	ini2reg( "AudioPath", "REG_SZ" )
	ini2reg( "VstPath", "REG_SZ" )
	ini2reg( "LoadLastFile", "REG_DWORD" )
	ini2reg( "Audio Out GUID", "REG_SZ" )
	ini2reg( "CurrentMidiInDev", "REG_DWORD" )
	ini2reg( "CurrentMidiOutDev", "REG_DWORD" )
	ini2reg( "HiQualityGraphics", "REG_DWORD" )
	ini2reg( "LastFile", "REG_SZ" )
	ini2reg( "Latency", "REG_DWORD" )
	ini2reg( "SRATE", "REG_DWORD" )
	ini2reg( "Window Bottom", "REG_DWORD" )
	ini2reg( "Window Left", "REG_DWORD" )
	ini2reg( "Window Maximised", "REG_DWORD" )
	ini2reg( "Window Right", "REG_DWORD" )
	ini2reg( "Window Top", "REG_DWORD" )
EndFunc

Func ini2reg($key, $type)
	$value = IniRead($iniFileName, $inisection, $key, "not found")
	if $value <> "not found" Then
		RegWrite($baseKeyPath, $key, $type, $value )
	EndIf
EndFunc	
		
Func registry2ini()
	reg2ini( "MidiPath" )
	reg2ini( "AudioPath" )
	reg2ini( "VstPath" )
	reg2ini( "LoadLastFile" )
	reg2ini( "Audio Out GUID" )
	reg2ini( "CurrentMidiInDev" )
	reg2ini( "CurrentMidiOutDev" )
	reg2ini( "HiQualityGraphics" )
	reg2ini( "LastFile" )
	reg2ini( "Latency" )
	reg2ini( "SRATE" )
	reg2ini( "Window Bottom" )
	reg2ini( "Window Left" )
	reg2ini( "Window Maximised" )
	reg2ini( "Window Right" )
	reg2ini( "Window Top" )
EndFunc

Func reg2ini($key)
	$value = RegRead( $baseKeyPath , $key)
	if @error == 0 Then	
		IniWrite( $iniFileName, $inisection, $key, $value )
	EndIf
EndFunc	

Func getSaveDirName(ByRef $dir, $fileName="filename" )
	Local $fullName = FileSaveDialog( $caption , $dir, $fileFilter , 2, $fileName )
	If NOT @error Then
		$fileArray = _myPathSplit($fullName)
		$dir = $fileArray[0]
		IniWrite ( $iniFileName, $iniSection, $iniKey, $dir )	 
		Return True
	Else
		Return False
	EndIf	
EndFunc	

Func getSaveExeName(ByRef $fullname, $fileName="SynthEdit.exe" )
	$fullName = FileSaveDialog( $caption , $dir, $fileFilter , 2, $fileName )
	If NOT @error Then
		$fileArray = _myPathSplit($fullName)
		If $fileArray[1] == "SynthEdit.exe" Then
			IniWrite ( $iniFileName, $iniSection, $iniKey, $fullName )	
			Return True
		Else
			Return False
		EndIf
	Else
		Return False
	EndIf	
EndFunc	

Func _myPathSplit($szPath)
	; Set local strings to null (We use local strings in case one of the arguments is the same variable)
	Local $dir = ""
	Local $fname = ""
	Local $i, $pos; For Opt("MustDeclareVars", 1)
	
	; Create an array which will be filled and returned later
	Local $array[2]
	; Set the directory and file name if present
	$i = StringLen($szPath)
	If StringMid($szPath, $i, 1) = "\" Or StringMid($szPath, $i, 1) = "/" Then
		;MsgBox(4096, "_myPathSplit", "trimmed 1")
		$szPath = StringTrimRight($szPath, 1)
	EndIf	
		
	For $i = StringLen($szPath) To 0 Step - 1
		If StringMid($szPath, $i, 1) = "\" Or StringMid($szPath, $i, 1) = "/" Then
			$dir = StringLeft($szPath, $i)
			$fname = StringRight($szPath, StringLen($szPath) - $i)
			ExitLoop
		EndIf
	Next
	
	; If $szDir wasn't set, then the whole path must just be a file, so set the filename
	If StringLen($dir) = 0 Then $fname = $szPath
	
	; Set the strings and array to what we found
	$array[0] = $dir
	$array[1] = $fname
	;MsgBox(4096, "_myPathSplit", $dir & "     " & $fname)
	Return $array
EndFunc   ;==>_myPathSplit	